//---------------------------------------------------------------------------
// Created 27-Sep-2003: Thomas Mulgrew (tmulgrew@slingshot.co.nz)
// Copyright (C) Thomas Mulgrew
#ifndef Basic4GLv2MainH
#define Basic4GLv2MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnList.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "TomComp.h"
#include <Dialogs.hpp>                // Basic compiler
#include <glWindow.h>
#include <AppEvnts.hpp>
#include <Buttons.hpp>
#include <StdActns.hpp>
#include "MemoEx.hpp"
#include <Grids.hpp>
#include <gl\gl.h>
#include <gl\glu.h>
#include "glSpriteEngine.h"
#include "VirtualMachineView.h"
#include "EmbeddedFiles.h"
//---------------------------------------------------------------------------

enum ApMode { AP_RUNNING, AP_PAUSED, AP_STOPPED };
class TBasic4GLv2MainForm : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *GLBasic1;
    TMenuItem *Run1;
    TActionList *ActionList1;
    TAction *SaveAction;
    TAction *LoadAction;
    TAction *SaveAsAction;
    TAction *RunAction;
    TMenuItem *Open1;
    TMenuItem *Save1;
    TMenuItem *SaveAs1;
    TAction *AboutAction;
    TMenuItem *Help1;
    TMenuItem *AboutGLBasic1;
    TToolBar *ToolBar1;
    TImageList *Images;
    TToolButton *ToolButton1;
    TMenuItem *N1;
    TToolButton *ToolButton2;
    TToolButton *ToolButton3;
    TToolButton *ToolButton4;
    TToolButton *ToolButton5;
    TAction *NewAction;
    TOpenDialog *OpenDialog;
    TSaveDialog *SaveDialog;
    TStatusBar *StatusBar;
    TApplicationEvents *ApplicationEvents1;
    TAction *OptionsAction;
    TMenuItem *GLBasic2;
    TMenuItem *Options1;
    TMenuItem *Edit1;
    TMenuItem *Cut1;
    TMenuItem *Copy1;
    TMenuItem *Paste1;
    TMenuItem *SelectAll1;
    TMenuItem *N2;
    TMenuItem *Undo1;
    TMenuItem *Search1;
    TAction *VMAction;
    TMenuItem *VirtualMachine1;
    TAction *ShowFunctionsAction;
    TMenuItem *N3;
    TMenuItem *FunctionList1;
    TMenuItem *N4;
    TColorSelect *ColorSelect1;
    TFontEdit *FontEdit1;
    TMenuItem *SelectColor1;
    TMenuItem *SelectFont1;
    TPopupMenu *PopupMenu1;
    TMenuItem *Cut2;
    TMenuItem *Copy2;
    TMenuItem *Paste2;
    TMenuItem *N5;
    TMenuItem *Run2;
    TMenuItem *N7;
    TMenuItem *Undo2;
    TMenuItem *N8;
    TMenuItem *GettingStarted1;
    TMenuItem *ProgrammersGuide1;
    TMenuItem *LanguageGuide1;
    TMenuItem *OpenGLGuide1;
    TEditCut *EditCut1;
    TEditCopy *EditCopy1;
    TEditPaste *EditPaste1;
    TEditSelectAll *EditSelectAll1;
    TEditUndo *EditUndo1;
    TEditDelete *EditDelete1;
    TImageList *GutterImages;
    TMemoEx *SourceCode;
    TAction *FindAction;
    TAction *FindNextAction;
    TAction *ReplaceAction;
    TMenuItem *Find1;
    TMenuItem *FindNext1;
    TMenuItem *FindandReplace1;
    TFindDialog *FindDialog;
    TReplaceDialog *ReplaceDialog;
    TPanel *Panel1;
    TToolBar *DebugBar;
    TToolButton *ToolButton6;
    TToolButton *ToolButton7;
    TAction *PlayPauseAction;
    TAction *StepAction;
    TToolButton *ToolButton8;
    TToolButton *ToolButton9;
    TToolButton *ToolButton10;
    TAction *StepIntoAction;
    TAction *StepOutOfAction;
    TToolButton *ToolButton12;
    TPanel *DebugPanel;
    TSplitter *DebugSplitter;
    TSplitter *Splitter2;
    TToolButton *ToolButton13;
    TToolButton *DebugButton;
    TAction *DebugAction;
    TBevel *Bevel1;
    TMenuItem *DebugMode1;
    TMenuItem *DebugMenu;
    TMenuItem *PlayPause1;
    TMenuItem *StepInto1;
    TMenuItem *StepOutof1;
    TMenuItem *Step1;
    TMenuItem *N6;
    TToolButton *ToolButton14;
    TListBox *GosubListBox;
    TListBox *WatchListBox;
    TAction *AddWatchAction;
    TMenuItem *N9;
    TMenuItem *AddWatch1;
    TMenuItem *SymbolicDebuggerGuide1;
    TMenuItem *N10;
    TMenuItem *Find2;
    TMenuItem *FindNext2;
    TMenuItem *FindandReplace2;
    TMenuItem *SpriteLibraryGuide1;
    TMenuItem *NewProgram1;
    TMenuItem *N11;
    TAction *CreateStandAlone;
    TMenuItem *CreateStandaloneexe1;
    TMenuItem *CreatingStandaloneexes1;
    void __fastcall AboutActionExecute(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall SaveAsActionExecute(TObject *Sender);
    void __fastcall NewActionExecute(TObject *Sender);
    void __fastcall SaveActionExecute(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall LoadActionExecute(TObject *Sender);
    void __fastcall SourceCodeChange(TObject *Sender);
    void __fastcall RunActionExecute(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall ApplicationEvents1Idle(TObject *Sender, bool &Done);
    void __fastcall OptionsActionExecute(TObject *Sender);
    void __fastcall VMActionExecute(TObject *Sender);
    void __fastcall ShowFunctionsActionExecute(TObject *Sender);
    void __fastcall ColorSelect1Accept(TObject *Sender);
    void __fastcall ColorSelect1BeforeExecute(TObject *Sender);
    void __fastcall FontEdit1BeforeExecute(TObject *Sender);
    void __fastcall FontEdit1Accept(TObject *Sender);
    void __fastcall GettingStarted1Click(TObject *Sender);
    void __fastcall ProgrammersGuide1Click(TObject *Sender);
    void __fastcall LanguageGuide1Click(TObject *Sender);
    void __fastcall OpenGLGuide1Click(TObject *Sender);
    void __fastcall SourceCodeAdvancedPaintGutter(TObject *Sender,
          TCanvas *Canvas, TRect &Rect, int Index);
    void __fastcall SourceCodeGetLineAttr(TObject *Sender,
          const AnsiString Line, int Index, const TSelAttrs SelAttrs,
          TLineAttrs &Attrs);
    void __fastcall EditCut1Update(TObject *Sender);
    void __fastcall EditCut1Execute(TObject *Sender);
    void __fastcall EditCopy1Execute(TObject *Sender);
    void __fastcall EditPaste1Execute(TObject *Sender);
    void __fastcall EditSelectAll1Update(TObject *Sender);
    void __fastcall EditSelectAll1Execute(TObject *Sender);
    void __fastcall EditUndo1Update(TObject *Sender);
    void __fastcall EditUndo1Execute(TObject *Sender);
    void __fastcall EditDelete1Execute(TObject *Sender);
    void __fastcall FindActionUpdate(TObject *Sender);
    void __fastcall FindNextActionUpdate(TObject *Sender);
    void __fastcall FindActionExecute(TObject *Sender);
    void __fastcall PlayPauseActionExecute(TObject *Sender);
    void __fastcall SourceCodeGutterClick(TObject *Sender, int X, int Y,
          int Index);
    void __fastcall StepActionExecute(TObject *Sender);
    void __fastcall StepIntoActionExecute(TObject *Sender);
    void __fastcall StepOutOfActionExecute(TObject *Sender);
    void __fastcall DebugActionExecute(TObject *Sender);
    void __fastcall GosubListBoxClick(TObject *Sender);
    void __fastcall WatchListBoxDblClick(TObject *Sender);
    void __fastcall WatchListBoxKeyPress(TObject *Sender, char &Key);
    void __fastcall WatchListBoxKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall WatchListBoxClick(TObject *Sender);
    void __fastcall AddWatchActionExecute(TObject *Sender);
    void __fastcall SourceCodeMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall SymbolicDebuggerGuide1Click(TObject *Sender);
    void __fastcall FindDialogFind(TObject *Sender);
    void __fastcall FindNextActionExecute(TObject *Sender);
    void __fastcall ReplaceActionExecute(TObject *Sender);
    void __fastcall ReplaceDialogReplace(TObject *Sender);
    void __fastcall SpriteLibraryGuide1Click(TObject *Sender);
    void __fastcall CreateStandAloneExecute(TObject *Sender);
    void __fastcall CreatingStandaloneexes1Click(TObject *Sender);
private:	// User declarations

    // Virtual machine and compiler
    TomVM               m_vm;           // Virtual machine
    TomBasicCompiler    m_comp;         // Compiler
    FileOpener          m_files;

    // Virtual machine view
    TVirtualMachineViewForm  *m_vmView;

    // Editor state
    ApMode              m_mode;
    bool                m_modified;
    AnsiString          m_filename, m_startDirectory;
    TLineAttr           m_defaultStyle,
                        m_commentStyle,
                        m_keywordStyle,
                        m_stringStyle,
                        m_functionStyle,
                        m_numberStyle,
                        m_constantStyle;
    TColor              m_breakPtLineCol;

    // Debugging
    bool                    m_debugMode;
    std::list<std::string>  m_watches;
    bool                    m_delayScreenSwitch;            // Set when stepping. Delays switching to the output window for the first 1000 op-codes.
                                                            // (To prevent excessive screen mode switches when debugging full-screen programs.)

    void                RefreshActions ();                  // Enable/disable actions to reflect state
    void                PlaceCursor (int line, int col);    // Place cursor at line, col
    void                DefaultStyle (TLineAttr& style);
    void                ResetStyles ();

    // Compilation and execution routines
    void LoadProgramIntoCompiler ();
    bool Compile ();
    void Continue ();

    // File routines
    bool CheckModified ();              // Check whether file is modified, and allow user to save beforehand
    bool Save ();
    bool SaveAs ();
    char ReadChar (TFileStream& s);
    AnsiString ReadString (TFileStream& s);
    void WriteString (TFileStream& s, AnsiString str, bool addEol = true);

    // Search and replace
    bool Find (AnsiString text, bool caseSensitive);
    bool Replace (AnsiString findText, AnsiString replaceText, bool caseSensitive);

    // Debugging
    void ToggleBreakPt (int line);
    void DoStep (int type);
    void RefreshDebugDisplays ();
    std::string EvaluateWatch (std::string watch, bool canCallFunc);
    void EditWatch ();
    void DeleteWatch ();
    void UpdateWatchHint ();
    std::string GetVariableAt (int x, int y);
    bool IsValidBreakPt (int line);

    // Registry settings
    void LoadRegistrySettings ();
    void LoadScreenRegistrySettings (int& width, int& height, int& bpp, bool& fullScreen, bool& border, ResetGLModeType& resetMode);
    void SaveRegistrySettings ();

    // OpenGL window
    glTextGridWindow    *m_glWin;

    // OpenGL text display
    glTextGrid          *m_glText;

public:		// User declarations
    __fastcall TBasic4GLv2MainForm(TComponent* Owner);
    bool RunAndQuit (std::string filename);       // Run file once then quit. Returns true if filename is not blank.
};

//---------------------------------------------------------------------------
extern PACKAGE TBasic4GLv2MainForm *Basic4GLv2MainForm;
//---------------------------------------------------------------------------
#endif
