//---------------------------------------------------------------------------
// Created 27-Sep-2003: Thomas Mulgrew (tmulgrew@slingshot.co.nz)
// Copyright (C) Thomas Mulgrew
#include <vcl.h>
#pragma hdrstop

#include "FunctionReferenceDlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFunctionRefDlg *FunctionRefDlg;
//---------------------------------------------------------------------------
__fastcall TFunctionRefDlg::TFunctionRefDlg(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
std::string TypeString (vmValType type) {
    std::string result = "";
    for (int i = 0; i < type.VirtualPointerLevel (); i++)
        result = result + "&";

    switch (type.m_basicType) {
    case VTP_INT:       result = result + "int";    break;
    case VTP_REAL:      result = result + "real";   break;
    case VTP_STRING:    result = result + "string"; break;
    default:            result = result + "???";
    }

    for (int i = 0; i < type.m_arrayLevel; i++)
        result = result + "()";

    return result;
}

void TFunctionRefDlg::Populate (TomBasicCompiler& comp) {

    // Populate functions
    Edit->Clear ();
    for (   compStringIndex::iterator i = comp.FunctionIndex ().begin ();
            i != comp.FunctionIndex ().end ();
            i++) {

        // Find name and function data
        std::string     name = (*i).first;
        compFuncSpec&   spec = comp.Functions () [(*i).second];

        // Build description string
        std::string line = "";
        if (spec.m_isFunction)                                      // Return type
            line = line + TypeString (spec.m_returnType) + " ";
        line = line + name;                                         // Function name
        if (spec.m_brackets)                                        // Opening bracket
            line = line + "(";
        else
            line = line + " ";
        bool needComma = false;
        vmValTypeList& params = spec.m_paramTypes.Params ();
        for (   vmValTypeList::iterator parami = params.begin ();
                parami != params.end ();
                parami++) {
            if (needComma)
                line = line + ", ";
            line = line + TypeString (*parami);
            needComma = true;
        }
        if (spec.m_brackets)
            line = line + ")";

        // Store description string
        Edit->Lines->Add ((char *) line.c_str ());
    }

    // Populate constants
    Constants->Clear ();
    for (   compConstantMap::iterator i2 = comp.Constants ().begin ();
            i2 != comp.Constants ().end ();
            i2++) {

        // Build description string
        std::string line = (*i2).first + " (" + TypeString ((*i2).second.m_valType) + ")";
        Constants->Lines->Add ((char *) line.c_str ());
    }
}
//---------------------------------------------------------------------------

