//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ScreenMode.h"
#include "Basic4GLSettings.h"
#include <registry.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TScreenModeFrame *ScreenModeFrame;
//---------------------------------------------------------------------------
__fastcall TScreenModeFrame::TScreenModeFrame(TComponent* Owner)
    : TFrame(Owner)
{
}
//---------------------------------------------------------------------------
void TScreenModeFrame::LoadFromRegistry () {

    // Load settings from registry
    try {
        TRegistry *Reg = new TRegistry ();
        try
        {
            Reg->RootKey = HKEY_CURRENT_USER;
            if (Reg->OpenKeyReadOnly(REG_KEY)) {
                ScreenMode->ItemIndex   = Reg->ReadInteger ("ScreenMode");
                ColourDepth->ItemIndex  = Reg->ReadInteger ("ColourDepth");
                FullScreen->Checked     = Reg->ReadBool ("FullScreen");
                Border->Checked         = Reg->ReadBool ("Border");
                ResetMode->ItemIndex    = Reg->ReadInteger ("ResetGLMode");
            }
        }
        __finally
        {
            delete Reg;
        }
    } catch (...) {;}
}
//---------------------------------------------------------------------------
void TScreenModeFrame::SaveToRegistry () {

    // Save settings from registry
    TRegistry *Reg = new TRegistry;
    try
    {
        Reg->RootKey = HKEY_CURRENT_USER;
        if (Reg->OpenKey(REG_KEY, true)) {
            Reg->WriteInteger ("ScreenMode",  ScreenMode->ItemIndex );
            Reg->WriteInteger ("ColourDepth", ColourDepth->ItemIndex);
            Reg->WriteBool    ("FullScreen",  FullScreen->Checked   );
            Reg->WriteBool    ("Border",      Border->Checked       );
            Reg->WriteInteger ("ResetGLMode", ResetMode->ItemIndex  );
        }
    }
    __finally
    {
        delete Reg;
    }
}
//---------------------------------------------------------------------------
void __fastcall TScreenModeFrame::FullScreenClick(TObject *Sender)
{
    if (FullScreen->Checked) {
        ColourDepth->Enabled = true;
        Border->Enabled      = false;
    }
    else {
        ColourDepth->ItemIndex = 0;         // If not fullscreen, then force colour depth to use desktop
        ColourDepth->Enabled = false;
        Border->Enabled      = true;
    }
}
//---------------------------------------------------------------------------
