//---------------------------------------------------------------------------
/*  Created 13-Mar-2004: Thomas Mulgrew (tmulgrew@slingshot.co.nz)
    Copyright (C) Thomas Mulgrew
    Load and return image. (Uses Corona, and embedded files mechanism.)
*/

#ifndef LoadImageH
#define LoadImageH

#include "Corona.h"
#include "EmbeddedFiles.h"
#include <string>
#include <assert.h>
#include <windows.h>
#include <gl/gl.h>
//---------------------------------------------------------------------------

// InitLoadImage must be called at least once, so that routines can find the
// loader object.
void InitLoadImage (FileOpener *_files);

// LoadImage loads an image and converts it into a useful format
corona::Image *LoadImage (std::string filename);

// Return the image format as an OpenGL constant
inline GLuint ImageFormat (corona::Image *image) {
    assert (image != NULL);
    return (image->getFormat () & 0xffff) == corona::PF_R8G8B8 ? GL_RGB : GL_RGBA;
}

// Scale the image so that the sizes are a power of 2.
corona::Image *ResizeImageForOpenGL (corona::Image *src);

#endif
