/*	Created 29-Feb-2004: Thomas Mulgrew (tmulgrew@slingshot.co.nz)
	Copyright (C) Tom Mulgrew, 2004.

	Structures and routines for standalone Basic4GL programs.

	Standalone programs have all their necessary data patched into the end of the program
	by the standalone .exe generator.
	This module defines the structure of this data, along with the necessary routines to
	unpack it into a useable format.

*/

#ifndef _standalone_h
#define _standalone_h

#include "TomComp.h"
#include "EmbeddedFiles.h"

///////////////////////////////////////////////////////////////////////////////
// Standalone header

#define STANDALONE_VERSION 2

#ifndef byte
typedef unsigned char byte;
#endif

#pragma pack(push,1)
struct StandaloneHeader {
	int version;
    char title[32];
    byte finishedOption;
    byte errorOption;
    byte screenMode;
    byte colourDepth;
    bool fullScreen;
    bool escKeyQuits;
	bool border;
};
#pragma pack(pop)

bool UnpackStandaloneData (char *rawData, StandaloneHeader& header, compParser& parser, FileOpener& files);

#endif